--- old/usr/src/lib/fm/topo/libtopo/common/topo_string.c	2013-08-28 19:10:28.015194766 +0000
+++ new/usr/src/lib/fm/topo/libtopo/common/topo_string.c	2013-08-28 19:10:28.028087157 +0000
@@ -70,13 +70,12 @@
 		 * Start scanning at beginning of input:
 		 */
 		scanstart = input;
-	} else {
+	} else if (*lastp == NULL) {
 		/*
 		 * If we have already finished scanning, return NULL.
 		 */
-		if (*lastp == NULL)
-			return (NULL);
-
+		return (NULL);
+	} else {
 		/*
 		 * Otherwise, start scanning where we left off:
 		 */
@@ -91,7 +90,9 @@
 		 */
 		*lastp = token + seplen;
 		/*
-		 * Copy out this element:
+		 * Copy out this element.  The buffer must fit the string
+		 * exactly, so that topo_hdl_strfree() can determine its
+		 * size with strlen().
 		 */
 		ret = topo_hdl_alloc(hdl, token - scanstart + 1);
 		(void) strncpy(ret, scanstart, token - scanstart);
